import { AfterViewInit, ElementRef, OnInit, TemplateRef } from "@angular/core";
export declare enum Size {
    SMALL = "small",
    MEDIUM = "medium",
    LARGE = "large",
}
/**
 * **Ignite UI for Angular Avatar** -
 * [Documentation](https://www.infragistics.com/products/ignite-ui-angular/angular/components/avatar.html)
 *
 * The Ignite UI Avatar provides an easy way to add an avatar icon to your application.  This icon can be an
 * image, someone's initials or a material icon from the google material icon set.
 *
 * Example:
 * ```html
 * <igx-avatar initials="MS" roundShape="true" size="large">
 * </igx-avatar>
 * ```
 */
export declare class IgxAvatarComponent implements OnInit, AfterViewInit {
    elementRef: ElementRef;
    image: ElementRef;
    protected imageTemplate: TemplateRef<any>;
    protected initialsTemplate: TemplateRef<any>;
    protected iconTemplate: TemplateRef<any>;
    ariaLabel: string;
    role: string;
    cssClass: string;
    roleDescription: string;
    private _size;
    id: string;
    roundShape: boolean;
    color: string;
    bgColor: string;
    initials: string;
    icon: string;
    src: string;
    size: string | Size;
    readonly template: TemplateRef<any>;
    constructor(elementRef: ElementRef);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    private getRole();
}
export declare class IgxAvatarModule {
}
