import { CommonModule } from "@angular/common";
import { NgModule } from "@angular/core";
import { FormsModule } from "@angular/forms";
import { IgxCheckboxModule } from "../checkbox/checkbox.component";
import { IgxSelectionAPIService } from "../core/selection";
import { IgxDatePickerModule } from "../date-picker/date-picker.component";
import { IgxButtonModule } from "../directives/button/button.directive";
import { IgxFocusModule } from "../directives/focus/focus.directive";
import { IgxForOfModule } from "../directives/for-of/for_of.directive";
import { IgxRippleModule } from "../directives/ripple/ripple.directive";
import { IgxTextSelectionModule } from "../directives/text-selection/text-selection.directive";
import { IgxToggleModule } from "../directives/toggle/toggle.directive";
import { IgxIconModule } from "../icon";
import { IgxInputGroupModule } from "../input-group/input-group.component";
import { IgxGridAPIService } from "./api.service";
import { IgxGridCellComponent } from "./cell.component";
import { IgxColumnComponent } from "./column.component";
import { IgxGridFilterComponent } from "./grid-filtering.component";
import { IgxGridHeaderComponent } from "./grid-header.component";
import { IgxGridSummaryComponent } from "./grid-summary.component";
import { IgxCellEditorTemplateDirective, IgxCellFooterTemplateDirective, IgxCellHeaderTemplateDirective, IgxCellTemplateDirective, IgxColumnResizerDirective } from "./grid.common";
import { IgxGridComponent } from "./grid.component";
import { IgxGridFilterConditionPipe, IgxGridFilteringPipe, IgxGridPagingPipe, IgxGridSortingPipe } from "./grid.pipes";
import { IgxGridRowComponent } from "./row.component";
var IgxGridModule = /** @class */ (function () {
    function IgxGridModule() {
    }
    IgxGridModule.forRoot = function () {
        return {
            ngModule: IgxGridModule,
            providers: [IgxGridAPIService, IgxSelectionAPIService]
        };
    };
    IgxGridModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [
                        IgxGridCellComponent,
                        IgxColumnComponent,
                        IgxGridComponent,
                        IgxGridRowComponent,
                        IgxGridHeaderComponent,
                        IgxGridSummaryComponent,
                        IgxCellFooterTemplateDirective,
                        IgxCellHeaderTemplateDirective,
                        IgxCellEditorTemplateDirective,
                        IgxCellTemplateDirective,
                        IgxColumnResizerDirective,
                        IgxGridFilterComponent,
                        IgxGridSortingPipe,
                        IgxGridPagingPipe,
                        IgxGridFilteringPipe,
                        IgxGridFilterConditionPipe
                    ],
                    entryComponents: [
                        IgxColumnComponent
                    ],
                    exports: [
                        IgxGridComponent,
                        IgxGridCellComponent,
                        IgxGridRowComponent,
                        IgxColumnComponent,
                        IgxGridHeaderComponent,
                        IgxGridFilterComponent,
                        IgxGridSummaryComponent,
                        IgxCellFooterTemplateDirective,
                        IgxCellHeaderTemplateDirective,
                        IgxCellEditorTemplateDirective,
                        IgxCellTemplateDirective,
                        IgxColumnResizerDirective
                    ],
                    imports: [
                        CommonModule,
                        FormsModule,
                        IgxButtonModule,
                        IgxDatePickerModule,
                        IgxIconModule,
                        IgxRippleModule,
                        IgxInputGroupModule,
                        IgxToggleModule,
                        IgxForOfModule,
                        IgxFocusModule,
                        IgxTextSelectionModule,
                        IgxCheckboxModule
                    ],
                    providers: [IgxGridAPIService, IgxSelectionAPIService]
                },] },
    ];
    return IgxGridModule;
}());
export { IgxGridModule };
//# sourceMappingURL=index.js.map