import { ChangeDetectorRef, DoCheck, ElementRef, OnDestroy, OnInit, QueryList } from "@angular/core";
import { IgxCheckboxComponent } from "../checkbox/checkbox.component";
import { IgxSelectionAPIService } from "../core/selection";
import { IgxForOfDirective } from "../directives/for-of/for_of.directive";
import { IgxGridAPIService } from "./api.service";
import { IgxGridCellComponent } from "./cell.component";
import { IgxColumnComponent } from "./column.component";
import { IGridBus } from "./grid.common";
import { IgxGridComponent } from "./grid.component";
export declare class IgxGridRowComponent implements IGridBus, OnInit, OnDestroy, DoCheck {
    gridAPI: IgxGridAPIService;
    private selectionAPI;
    private element;
    cdr: ChangeDetectorRef;
    rowData: any;
    index: number;
    gridID: string;
    virtDirRow: IgxForOfDirective<any>;
    checkboxElement: IgxCheckboxComponent;
    cells: QueryList<IgxGridCellComponent>;
    readonly rowHeight: number;
    tabindex: number;
    role: string;
    readonly styleClasses: string;
    focused: boolean;
    readonly columns: IgxColumnComponent[];
    readonly pinnedColumns: IgxColumnComponent[];
    readonly unpinnedColumns: IgxColumnComponent[];
    readonly rowSelectable: boolean;
    isSelected: boolean;
    readonly grid: IgxGridComponent;
    readonly rowID: any;
    readonly nativeElement: any;
    protected defaultCssClass: string;
    protected _rowSelection: boolean;
    protected isFocused: boolean;
    protected chunkLoaded$: any;
    constructor(gridAPI: IgxGridAPIService, selectionAPI: IgxSelectionAPIService, element: ElementRef, cdr: ChangeDetectorRef);
    ngOnInit(): void;
    ngOnDestroy(): void;
    onFocus(event: any): void;
    onBlur(event: any): void;
    onCheckboxClick(event: any): void;
    readonly rowCheckboxAriaLabel: string;
    ngDoCheck(): void;
}
