/**
 * This file contains all the directives used by the @link IgxTimePickerComponent.
 * You should generally not use them directly.
 * @preferred
 */
import { ElementRef } from "@angular/core";
import { IgxTimePickerComponent } from "./time-picker.component";
/**
 * @hidden
 */
export declare class IgxItemListDirective {
    timePicker: IgxTimePickerComponent;
    private elementRef;
    type: string;
    isActive: boolean;
    constructor(timePicker: IgxTimePickerComponent, elementRef: ElementRef);
    tabindex: number;
    readonly defaultCSS: boolean;
    readonly hourCSS: boolean;
    readonly minuteCSS: boolean;
    readonly ampmCSS: boolean;
    onFocus(): void;
    onBlur(): void;
    private nextItem();
    private prevItem();
    /**
     * @hidden
     */
    onKeydownArrowDown(event: KeyboardEvent): void;
    /**
     * @hidden
     */
    onKeydownArrowUp(event: KeyboardEvent): void;
    /**
     * @hidden
     */
    onKeydownArrowRight(event: KeyboardEvent): void;
    /**
     * @hidden
     */
    onKeydownArrowLeft(event: KeyboardEvent): void;
    /**
     * @hidden
     */
    onKeydownEnter(event: KeyboardEvent): void;
    /**
     * @hidden
     */
    onKeydownEscape(event: KeyboardEvent): void;
    /**
     * @hidden
     */
    onHover(): void;
    /**
     * @hidden
     */
    onScroll(event: any): void;
    /**
     * @hidden
     */
    onPanMove(event: any): void;
}
export declare class IgxHourItemDirective {
    timePicker: IgxTimePickerComponent;
    private itemList;
    value: string;
    readonly defaultCSS: boolean;
    readonly selectedCSS: boolean;
    readonly activeCSS: boolean;
    readonly isSelectedHour: boolean;
    constructor(timePicker: IgxTimePickerComponent, itemList: IgxItemListDirective);
    onClick(item: any): void;
}
export declare class IgxMinuteItemDirective {
    timePicker: IgxTimePickerComponent;
    private itemList;
    value: string;
    readonly defaultCSS: boolean;
    readonly selectedCSS: boolean;
    readonly activeCSS: boolean;
    readonly isSelectedMinute: boolean;
    constructor(timePicker: IgxTimePickerComponent, itemList: IgxItemListDirective);
    onClick(item: any): void;
}
export declare class IgxAmPmItemDirective {
    timePicker: IgxTimePickerComponent;
    private itemList;
    value: string;
    readonly defaultCSS: boolean;
    readonly selectedCSS: boolean;
    readonly activeCSS: boolean;
    readonly isSelectedAmPm: boolean;
    constructor(timePicker: IgxTimePickerComponent, itemList: IgxItemListDirective);
    onClick(item: any): void;
}
